#include<vcl>
#include<stdlib>
#pragma hdrstop
#include "Unit1.h"
int maxx=16,maxy=16,displaysize=17,maxminen=40;
int **minenfeld;
bool **minen;
bool lost = false;
int opened = 0;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner)
   {
   randomize();
   minenfeld = new(int*[maxx]);
   minen = new(bool*[maxx]);
   for(int i = 0; i < maxx; i++)
      {
      minenfeld[i] = new(int[maxy]);
      minen[i] = new(bool[maxy]);
      for(int j = 0; j < maxy; j++)
         {
         minenfeld[i][j] = -1;
         minen[i][j] = 0;
         }
      }
   for(int m = maxminen; m > 0;)
      {
      int mx = random(maxx);
      int my = random(maxy);
      if(!minen[mx][my])
         {
         minen[mx][my] = 1;
         m--;
         }
      }
   }
//---------------------------------------------------------------------------
void __fastcall TForm1::FeldPaint(TObject *Sender)
   {
   Form1->Width = (maxx*displaysize+12)+(2*Feld->Left);
   Form1->Height = (maxy*displaysize+75);
   Feld->Height = maxy*displaysize+2;
   Feld->Width = maxx*displaysize+2;
   Feld->Canvas->Pen->Color = clBtnFace;
   Feld->Canvas->FillRect(TRect(0,0,Feld->Width,Feld->Height));

   Feld->Canvas->Pen->Color = clDkGray;
   for(int i = 0; i <= maxx; i++)
      {
      Feld->Canvas->MoveTo(displaysize*i,0);
      Feld->Canvas->LineTo(displaysize*i,displaysize*maxy);
      }
   for(int i = 0; i <= maxy; i++)
      {
      Feld->Canvas->MoveTo(0,displaysize*i);
      Feld->Canvas->LineTo(displaysize*maxx,displaysize*i);
      }
   for(int x = 0; x < maxx; x++)
      for(int y = 0; y < maxy; y++)
         {
         Feld->Canvas->Font->Style = TFontStyles() << fsBold;
         switch(minenfeld[x][y])
            {
            case -1: case -2: case -3:
                     Feld->Canvas->Pen->Color = clWhite;
                     Feld->Canvas->MoveTo(x*displaysize,y*displaysize);
                     Feld->Canvas->LineTo((x+1)*displaysize-1,y*displaysize);
                     Feld->Canvas->Pen->Color = clDkGray;
                     Feld->Canvas->LineTo((x+1)*displaysize-1,(y+1)*displaysize-1);
                     Feld->Canvas->LineTo(x*displaysize,(y+1)*displaysize-1);
                     Feld->Canvas->Pen->Color = clWhite;
                     Feld->Canvas->LineTo(x*displaysize,y*displaysize);

                     if(minenfeld[x][y] == -2)
                        {
                        Feld->Canvas->Font->Color = clRed;
                        Feld->Canvas->TextOut(displaysize*x+4,displaysize*y+2,"X");
                        }
                     if(minenfeld[x][y] == -3)
                        {
                        Feld->Canvas->Font->Color = clBlack;
                        Feld->Canvas->TextOut(displaysize*x+4,displaysize*y+2,"\?");
                        }
                     break;
            case 1 : Feld->Canvas->Font->Color = clBlue;
                     Feld->Canvas->TextOut(displaysize*x+4,displaysize*y+2,minenfeld[x][y]);
                     break;
            case 2 : Feld->Canvas->Font->Color = clGreen;
                     Feld->Canvas->TextOut(displaysize*x+4,displaysize*y+2,minenfeld[x][y]);
                     break;
            case 3 : Feld->Canvas->Font->Color = clPurple;
                     Feld->Canvas->TextOut(displaysize*x+4,displaysize*y+2,minenfeld[x][y]);
                     break;
            case 4 : Feld->Canvas->Font->Color = clNavy;
                     Feld->Canvas->TextOut(displaysize*x+4,displaysize*y+2,minenfeld[x][y]);
                     break;
            case 5 : Feld->Canvas->Font->Color = clMaroon;
                     Feld->Canvas->TextOut(displaysize*x+4,displaysize*y+2,minenfeld[x][y]);
                     break;
            case 6 : Feld->Canvas->Font->Color = clTeal;
                     Feld->Canvas->TextOut(displaysize*x+4,displaysize*y+2,minenfeld[x][y]);
                     break;
            case 7 : Feld->Canvas->Font->Color = clNavy;
                     Feld->Canvas->TextOut(displaysize*x+4,displaysize*y+2,minenfeld[x][y]);
                     break;
            case 8 : Feld->Canvas->Font->Color = clNavy;
                     Feld->Canvas->TextOut(displaysize*x+4,displaysize*y+2,minenfeld[x][y]);
            }
         }
   }
void __fastcall TForm1::FeldMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
   {
   int x = X/displaysize;
   int y = Y/displaysize;
   if(lost) return;
   if(X<0 || x>=maxx || Y<0 || y>=maxy) return;
   if(minenfeld[x][y] >= 0) return;

   if(Button == mbRight && minenfeld[x][y] < 0)
      {
      minenfeld[x][y]--;
      if(minenfeld[x][y] == -4)
         minenfeld[x][y] = -1;

      if(minenfeld[x][y] == -2)
         for(int ty = -1; ty <= 1; ty++)
            for(int tx = -1; tx <= 1; tx++)
               {
               if(x+tx<0 || x+tx>=maxx || y+ty<0 || y+ty>=maxy)
                  continue;
               if(minenfeld[x+tx][y+ty] < 0)
                  continue;
               int tm = 0, tfm = 0, tf = 0;
               for(int tty = -1; tty <= 1; tty++)
                  for(int ttx = -1; ttx <= 1; ttx++)
                     if(x+tx+ttx >= 0 && x+tx+ttx < maxx)
                        if(y+ty+tty >= 0 && y+ty+tty < maxy)
                           {
                           tf += (minenfeld[x+tx+ttx][y+ty+tty] == -1);
                           tm += (minen[x+tx+ttx][y+ty+tty]);
                           tfm += (minenfeld[x+tx+ttx][y+ty+tty] == -2);
                           }
               if(tm==tfm)
                  {
                  for(int ttx = -1; ttx <= 1; ttx++)
                     for(int tty = -1; tty <= 1; tty++)
                        FeldMouseUp(NULL,mbLeft,Shift,X+(tx*displaysize)+(ttx*displaysize),Y+(ty*displaysize)+(tty*displaysize));
                  }
               if(tfm+tf==tm)
                  {
                  for(int ttx = -1; ttx <= 1; ttx++)
                     for(int tty = -1; tty <= 1; tty++)
                        if(x+tx+ttx >= 0 && x+tx+ttx < maxx)
                           if(y+ty+tty >= 0 && y+ty+tty < maxy)
                              if(minenfeld[x+tx+ttx][y+ty+tty] != -2)
                                 FeldMouseUp(NULL,mbRight,Shift,X+(tx*displaysize)+(ttx*displaysize),Y+(ty*displaysize)+(tty*displaysize));
                  }
               }
      }
   if(Button == mbLeft && (minenfeld[x][y] == -1 || minenfeld[x][y] == -3))
      {
      if(minen[x][y])
         {
         Application->MessageBox("you lost","you lost",MB_OK);
         lost = true;
         return;
         }
      int TouchMines = 0, TouchFields = 0, TouchFoundMines = 0;
      for(int ty = -1; ty <= 1; ty++)
         for(int tx = -1; tx <= 1; tx++)
            if(x+tx>=0 && x+tx<maxx && y+ty>=0 && y+ty<maxy)
               {
               TouchFields += (minenfeld[x+tx][y+ty] == -1);
               TouchFoundMines += (minenfeld[x+tx][y+ty] == -2);
               TouchMines += minen[x+tx][y+ty];
               }
      minenfeld[x][y] = TouchMines;
      if(TouchMines == TouchFoundMines)
         {
         for(int ty = -1; ty <= 1; ty++)
            for(int tx = -1; tx <= 1; tx++)
               FeldMouseUp(NULL,mbLeft,Shift,X+tx*displaysize,Y+ty*displaysize);
         }
      if(TouchFields+TouchFoundMines == TouchMines)
         {
         for(int ty = -1; ty <= 1; ty++)
            for(int tx = -1; tx <= 1; tx++)
               if(x+tx>=0 && x+tx<maxx && y+ty>=0 && y+ty<maxy)
                  if(minenfeld[x+tx][y+ty] != -2)
                     FeldMouseUp(NULL,mbRight,Shift,X+tx*displaysize,Y+ty*displaysize);
         }
      if(++opened == maxx*maxy-maxminen)
         {
         FeldPaint(NULL);
         Application->MessageBox("you survived","congrats",MB_OK);
         return;
         }         
      }

   for(int ty = -1; ty <= 1; ty++)
      for(int tx = -1; tx <= 1; tx++)
         {
         if(x+tx<0 || x+tx>=maxx || y+ty<0 || y+ty>=maxy)
            continue;
         if(minenfeld[x+tx][y+ty] < 0)
            continue;
         int tm = 0, tfm = 0, tf = 0;
         for(int tty = -1; tty <= 1; tty++)
            for(int ttx = -1; ttx <= 1; ttx++)
               if(x+tx+ttx >= 0 && x+tx+ttx < maxx)
                  if(y+ty+tty >= 0 && y+ty+tty < maxy)
                     {
                     tf += (minenfeld[x+tx+ttx][y+ty+tty] == -1);
                     tm += (minen[x+tx+ttx][y+ty+tty]);
                     tfm += (minenfeld[x+tx+ttx][y+ty+tty] == -2);
                     }
         if(tm==tfm)
            {
            for(int ttx = -1; ttx <= 1; ttx++)
               for(int tty = -1; tty <= 1; tty++)
                  if(x+tx+ttx >= 0 && x+tx+ttx < maxx)
                     if(y+ty+tty >= 0 && y+ty+tty < maxy)
                        if(minenfeld[x+tx+ttx][y+ty+tty] == -1)
                           FeldMouseUp(NULL,mbLeft,Shift,X+(tx*displaysize)+(ttx*displaysize),Y+(ty*displaysize)+(tty*displaysize));
            }
         if(tfm+tf==tm)
            {
            for(int ttx = -1; ttx <= 1; ttx++)
               for(int tty = -1; tty <= 1; tty++)
                  if(x+tx+ttx >= 0 && x+tx+ttx < maxx)
                     if(y+ty+tty >= 0 && y+ty+tty < maxy)
                        if(minenfeld[x+tx+ttx][y+ty+tty] != -2)
                           FeldMouseUp(NULL,mbRight,Shift,X+(tx*displaysize)+(ttx*displaysize),Y+(ty*displaysize)+(tty*displaysize));
            }
         }
   if(Sender != NULL)
      FeldPaint(NULL);
   }

void __fastcall TForm1::Button1Click(TObject *Sender)
   {
   for(int i = 0; i < maxx; i++)
      {
      delete(minenfeld[i]);
      delete(minen[i]);
      }
   delete(minenfeld);
   delete(minen);
   // ===========================
   lost = false;
   opened = 0;
   randomize();
   minenfeld = new(int*[maxx]);
   minen = new(bool*[maxx]);
   for(int i = 0; i < maxx; i++)
      {
      minenfeld[i] = new(int[maxy]);
      minen[i] = new(bool[maxy]);
      for(int j = 0; j < maxy; j++)
         {
         minenfeld[i][j] = -1;
         minen[i][j] = 0;
         }
      }
   for(int m = maxminen; m > 0;)
      {
      int mx = random(maxx);
      int my = random(maxy);
      if(!minen[mx][my])
         {
         minen[mx][my] = 1;
         m--;
         }
      }
   FeldPaint(NULL);
   }
